module Bounce 

   /* Clean Game Library example using Tile Studio */

import StdEnv, GameLibrary

import BounceGfx   /* generated by Tile Studio */

SCREEN_SIZE :== {w = 640, h = 480}

Start world = defaultGame (defaultGameDef [myLevel]) [ScreenSize SCREEN_SIZE, ColorDepth 8] world

myLevel = defaultGameLevel Nothing [BackBackGroundLayer, BrickPlayFieldLayer]
              BrickPlayFieldBoundMap [Ball] id

OBJ_BALL :== 0x10   /* map code used in Tile Studio to place this object */

Ball = { defaultGameObject OBJ_BALL size Void
       & sprites = [BallSprite1]
       , init = (newinit size Void)
       }
where
    size = {w = 16, h = 16}
    newinit size state subcode pos time gs
        # (objrec, gs) = defaultObjectRec subcode pos size time gs
        # objrec = { objrec
                   & speed        = {rx = 2.0, ry = 3.0}
                   , bounce       = {fvx = Factor 1.0, fvy = Factor 1.0}
                   , bouncebounds = BND_STATIC_BOUNDS
                   }
        # (_, gs) = createObjectFocus { scrollleft      = sz.w / 3
                                      , scrollup        = sz.h / 3
                                      , scrollright     = sz.w / 3
                                      , scrolldown      = sz.h / 3
                                      , maxxscrollspeed = 16
                                      , maxyscrollspeed = 16 
                                      } gs
        = {st = state, or = objrec, gs = gs}
    where
        sz = SCREEN_SIZE
